Ruby: pm_optional_parameter_node Struct Reference

Ruby 3.4.6p54 (2025-09-16 revision dbd83256b1cec76c69756ecb8758b9e1079833de)

Data Fields
pm_optional_parameter_node Struct Reference

OptionalParameterNode. More...

`#include <ast.h>`

## Data Fields
pm_node_t | base
| The embedded base node.
pm_constant_id_t | name
| OptionalParameterNode#name.
pm_location_t | name_loc
| OptionalParameterNode#name_loc.
pm_location_t | operator_loc
| OptionalParameterNode#operator_loc.
struct pm_node * | value
| OptionalParameterNode#value.
Data Fields inherited from pm_node
pm_node_type_t | type
| This represents the type of the node.
pm_node_flags_t | flags
| This represents any flags on the node.
uint32_t | node_id
| The unique identifier for this node, which is deterministic based on the source.
pm_location_t | location
| This is the location of the node in the source.

## Detailed Description

OptionalParameterNode.

Represents an optional parameter to a method, block, or lambda definition.

    def a(b = 1)
          ^^^^^
    end

Type: ::PM_OPTIONAL_PARAMETER_NODE

Flags (#pm_parameter_flags):

- ::PM_PARAMETER_FLAGS_REPEATED_PARAMETER

Definition at line 6492 of file ast.h.

## Field Documentation

## ◆ base

pm_node_t pm_optional_parameter_node::base

The embedded base node.

Definition at line 6494 of file ast.h.

Referenced by pm_dump_json().

## ◆ name

pm_constant_id_t pm_optional_parameter_node::name

OptionalParameterNode#name.

Definition at line 6500 of file ast.h.

Referenced by pm_dump_json().

## ◆ name_loc

pm_location_t pm_optional_parameter_node::name_loc

OptionalParameterNode#name_loc.

Definition at line 6505 of file ast.h.

Referenced by pm_dump_json().

## ◆ operator_loc

pm_location_t pm_optional_parameter_node::operator_loc

OptionalParameterNode#operator_loc.

Definition at line 6510 of file ast.h.

Referenced by pm_dump_json().

## ◆ value

struct pm_node* pm_optional_parameter_node::value

OptionalParameterNode#value.

Definition at line 6515 of file ast.h.

Referenced by pm_dump_json(), pm_node_destroy(), and pm_visit_child_nodes().

The documentation for this struct was generated from the following file:

- prism/ast.h